`timescale 1ns / 1ps

module fsm(
    output reg enable1,
    output reg enable2,
    output reg do,
    output reg enable3,
    output reg enable4,
    output reg show,
    input clk,
    input rst_n,
    input next
    );
    reg [3:0] state;
    reg [3:0] next_state;
    
    always@*
        case(state)
            4'b0000:
              if(next)
                begin
                next_state = 4'b0001;
                enable1 = 0;
                enable2 = 0;
                do = 0;
                enable3 = 0;
                enable4 = 0;
                show = 0;
                end
              else
                begin
                next_state = 4'b0000;
                enable1 = 0;
                enable2 = 0;
                do = 0;
                enable3 = 0;
                enable4 = 0;
                show = 1;
                end
            4'b0001:
              if(next)
                begin
                next_state = 4'b0010;
                enable1 = 1;
                enable2 = 0;
                do = 0;
                enable3 = 0;
                enable4 = 0;
                show = 0;
                end
              else
                begin
                next_state = 4'b001;
                enable1 = 0;
                enable2 = 0;
                do = 0;
                enable3 = 0;
                enable4 = 0;
                show = 0;
                end
            4'b0010:
              if(next)
                begin
                next_state = 4'b0011;
                enable1 = 0;
                enable2 = 0;
                do = 0;
                enable3 = 0;
                enable4 = 0;
                show = 0;
                end
              else
                begin
                next_state = 4'b0010;
                enable1 = 1;
                enable2 = 0;
                do = 0;
                enable3 = 0;
                enable4 = 0;
                show = 0;
                end
            4'b0011:
              if(next)
                begin
                next_state = 4'b0100;
                enable1 = 0;
                enable2 = 1;
                do = 0;
                enable3 = 0;
                enable4 = 0;
                show = 0;
                end
              else
                begin
                next_state = 4'b0011;
                enable1 = 0;
                enable2 = 0;
                do = 0;
                enable3 = 0;
                enable4 = 0;
                show = 0;
                end
            4'b0100:
              if(next)
                begin
                next_state = 4'b0101;
                enable1 = 0;
                enable2 = 0;
                do = 0;
                enable3 = 0;
                enable4 = 0;
                show = 0;
                end
              else
                begin
                next_state = 4'b0100;
                enable1 = 0;
                enable2 = 1;
                do = 0;
                enable3 = 0;
                enable4 = 0;
                show = 0;
                end
            4'b0101:
              if(next)
                begin
                next_state = 4'b0110;
                enable1 = 0;
                enable2 = 0;
                do = 1;
                enable3 = 0;
                enable4 = 0;
                show = 0;
                end
              else
                begin
                next_state = 4'b0101;
                enable1 = 0;
                enable2 = 0;
                do = 0;
                enable3 = 0;
                enable4 = 0;
                show = 0;
                end
            4'b0110:
              if(next)
                begin
                next_state = 4'b0111;
                enable1 = 0;
                enable2 = 0;
                do = 0;
                enable3 = 0;
                enable4 = 0;
                show = 0;
                end
              else
                begin
                next_state = 4'b0110;
                enable1 = 0;
                enable2 = 0;
                do = 1;
                enable3 = 0;
                enable4 = 0;
                show = 0;
                end
            4'b0111:
              if(next)
                begin
                next_state = 4'b1000;
                enable1 = 0;
                enable2 = 0;
                do = 0;
                enable3 = 1;
                enable4 = 0;
                show = 0;
                end
              else
                begin
                next_state = 4'b0111;
                enable1 = 0;
                enable2 = 0;
                do = 0;
                enable3 = 0;
                enable4 = 0;
                show = 0;
                end
            4'b1000:
              if(next)
                begin
                next_state = 4'b1001;
                enable1 = 0;
                enable2 = 0;
                do = 0;
                enable3 = 0;
                enable4 = 0;
                show = 0;
                end
              else
                begin
                next_state = 4'b1000;
                enable1 = 0;
                enable2 = 0;
                do = 0;
                enable3 = 1;
                enable4 = 0;
                show = 0;
                end
            4'b1001:
              if(next)
                begin
                next_state = 4'b1010;
                enable1 = 0;
                enable2 = 0;
                do = 0;
                enable3 = 0;
                enable4 = 1;
                show = 0;
                end
              else
                begin
                next_state = 4'b1001;
                enable1 = 0;
                enable2 = 0;
                do = 0;
                enable3 = 0;
                enable4 = 0;
                show = 0;
                end
            4'b1010:
              if(next)
                begin
                next_state = 4'b1011;
                enable1 = 0;
                enable2 = 0;
                do = 0;
                enable3 = 0;
                enable4 = 0;
                show = 0;
                end
              else
                begin
                next_state = 4'b1010;
                enable1 = 0;
                enable2 = 0;
                do = 0;
                enable3 = 0;
                enable4 = 1;
                show = 0;
                end
            4'b1011:
              if(next)
                begin
                next_state = 4'b0000;
                enable1 = 0;
                enable2 = 0;
                do = 0;
                enable3 = 0;
                enable4 = 0;
                show = 1;
                end
              else
                begin
                next_state = 4'b1011;
                enable1 = 0;
                enable2 = 0;
                do = 0;
                enable3 = 0;
                enable4 = 0;
                show = 0;
                end
            default:
              begin
                next_state = 4'b0000;
                enable1 = 0;
                enable2 = 0;
                do = 0;
                enable3 = 0;
                enable4 = 0;
                show = 1;
                end
            endcase
            
    always@(posedge clk or negedge rst_n)
        if(~rst_n) state <= 2'b00;
        else state <= next_state;
        
endmodule
