`timescale 1ns / 1ps

module lab8_3(
    output [7:0] ssd,
    output [3:0] yes,
    output reg [15:0] light,
    inout wire PS2_DATA,
	inout wire PS2_CLK,
    input wire rst_n,
	input wire clk
    );
    wire [1:0] ctl; wire [3:0] ssd_in;
    wire [511:0] key_down; wire [8:0] last_change; wire key_valid;
    wire [3:0] num; reg [3:0] num_save, num1, num2, num3, num4, s;
    reg [4:0] sum;
    wire [3:0] q3, q2, q1, q0;
    wire enable1, enable2, enable3, enable4, do, show;

    always@*
        light = {num_save, s, enable1, enable2, do, enable3, enable4, show, 2'b0};
    always@*
	   if(key_valid) num_save = num;
	   else num_save = num_save;
	always@*
	   if(enable1 && key_valid) 
	       begin
	       num1 = num_save;
	       num2 = 4'd0;
	       s = 4'd0;
	       num3 = 4'd0;
	       num4 = 4'd0;
	       end
	   else if(enable2 && key_valid)
	       begin
	       num1 = num1;
	       num2 = num_save;
	       s = 4'd0;
	       num3 = 4'd0;
	       num4 = 4'd0;
	       end
	   else if(do && key_valid)
	       begin
	       num1 = num1;
	       num2 = num2;
	       s = num_save;
	       num3 = 4'd0;
	       num4 = 4'd0;
	       end
	   else if(enable3 && key_valid)
	       begin
	       num1 = num1;
	       num2 = num2;
	       s = s;
	       num3 = num_save;
	       num4 = 4'd0;
	       end
	   else if(enable4 && key_valid)
	       begin
	       num1 = num1;
	       num2 = num2;
	       s = s;
	       num3 = num3;
	       num4 = num_save;
	       end
	   else 
	       begin
	       num1 = num1;
	       num2 = num2;
	       s = s;
	       num3 = num3;
	       num4 = num4;
	       end
	       
    KeyboardDecoder U_keyboard(
	  .key_down(key_down),
	  .last_change(last_change),
	  .key_valid(key_valid),
	  .PS2_DATA(PS2_DATA),
	  .PS2_CLK(PS2_CLK),
	  .rst(~rst_n),
	  .clk(clk)
    );
    fsm U_fsm(
      .enable1(enable1),
      .enable2(enable2),
      .do(do),
      .enable3(enable3),
      .enable4(enable4),
      .show(show),
      .clk(clk),
      .rst_n(rst_n),
      .next(key_valid)
    );
    change U_change(
      .num(num),
      .last_change(last_change)
    );
    calculate U_calculate(
      .q0(q0),
      .q1(q1),
      .q2(q2),
      .q3(q3),
      .num1(num1),
      .num2(num2),
      .s(s),
      .num3(num3),
      .num4(num4),
      .show(show),
      .do(do)
    );
    freqdiv_ctl2 U_1HZ(
      .ctl(ctl),
      .clk(clk),
      .rst_n(rst_n)
    );
    scan_ctl U_SC(
     .ssd_ctl(yes),
     .ssd_in(ssd_in),
     .in0(q0),
     .in1(q1),
     .in2(q2),
     .in3(q3),
     .ssd_ctl_en(ctl) 
    );
    display_n U_D(
     .i(ssd_in),
     .SSD(ssd)
    );
endmodule
